#include <fastgl/fastgl.h>

#if defined( __linux__) || defined( __rtems__)
extern "C" char texture[] asm("_texture");			// bitmap in exe
#ifdef  __rtems__
extern "C" char new_bitmap[] asm("_new");			// bitmap in exe
extern "C" char icon_bitmap[] asm("_icon");			// bitmap in exe
#endif
#else
extern "C" char texture[];			// bitmap in exe
#endif

#ifdef __WATCOMC__
#pragma aux texture "_*"
#endif

Bitmap *b;

void exits(Control *)
{
    App::AppDone();
}

void proc(GuiEvent *p)
{
	switch(p->GetType())
	{
		case REPAINTEVENT:
		case INITEVENT:
			p->wnd->WindowPutBitmap(0, 0, 0, 0, p->wnd->GetWW(), p->wnd->GetHW(), b);
			set_fcolor(CBLUE);
			set_ppop(_GTRANSP);
#ifdef INDEX_COLORS
			p->wnd->printf(20, 20, " Used colors %d+16=%d \n", 0xf0 - GetFreeColors(), 0xf0 - GetFreeColors() + 16);
#endif
			p->wnd->printf(20, 40, "  You can minimize this window! \n");
			p->wnd->printf(20, 60, "and restore with right button again!\n");
			set_ppop(_GSET);
			break;
	}
}

int main(int argc, char **argv)
{
	App MyApp(2, argc, argv, 0, APP_ENABLEALTX|APP_ROOTWINDOW);
	SetColorFuzzy(2);			// how different colors you get
	Window *root = MyApp.GetRootWindow();

// NOTE: "in image" file not work in MSDOS Watcom !!!
#if (defined(__WATCOMC__) && defined(__MSDOS__) || !defined(INDEX_COLORS))
	Bitmap *a = new Bitmap("texture");	//  bitmap file (background texture)
#else
	Bitmap *a = new Bitmap((void *)texture);	// an in image bitmap (background texture)
#endif

#ifdef __rtems__
	b = new Bitmap( (void *)texture );	// create from file
	Bitmap c( (void *)new_bitmap );
 	Bitmap icon( (void *)icon_bitmap );
#else
  	b = new Bitmap("texture.bmp");	// create from file
  	Bitmap c("new");
  	Bitmap icon("icon");
#endif
	const int h = (Y_width / 100) * 40, w = (X_width / 100) * 40;

	// draw background  (size from header, position 0,0)
	root->WindowPutBitmap(0,0,0,0,X_width,Y_width, a);				

	root->WindowPutBitmap(200, 150, 0,0,400, 300, &c); // draw bitmap rectangle

	// create a window

	Window *okno1 = new Window(0, 20, 20, 360, 180, "The Window", proc, CBLACK, CWHITED,WFRAMED| WTITLED | WUSELAST|WSIZEABLE|WMINIMIZE);
	okno1->WindowAttachIcon(&icon);

	// add push button for exit

	okno1->AddPushButton(w - 100, h - 60, 80, 24, "The End", 'E', exits);

	// set colors

	set_colors(CBLACK, CWHITE);

	// print a message
	// save okno1 to bitmap file !!!
	Bitmap d(okno1);
	d.BitmapSave("window");

	// run while button pushed or ALT+X pressed
	MyApp.Run(0);
	delete b;
	delete a;
	delete okno1;
	return 0;
}
