/*
 *  This example shows PAGE FLIPPING feature of OpenGUI library
 *
 *	requirement: 1MB videocards (2MB for 16bit colors or 4MB for true colors)
 *	FPS (frames per secs) is based on monitor frequency & CPU speed heavily
*/

#include <fastgl/fastgl.h>

extern "C" int verbose; // be verbose


void animate(void)
{
	static int i=0,j=200,l=2000;
	set_ppop(_GSET);
	clear_frame_buffer(CWHITE);
	set_fcolor(CBLACK);
	fill_ellipse(X_width/2, Y_width/2,i,j);
	fill_ellipse(X_width/2, Y_width/2,j,i);
	i++;
	if (i==200) i=0;
	j--;
	if (j==0) j=200;
	Flip();
	if (l-- == 0) App::AppDone(); // return after 2000 frames
}

int main(int argc, char **argv)
{
	verbose = 1;
	App app(G640x480,argc,argv,0,APP_ENABLEALTX);

	// you can use FG_DOUBLEBUFFER or FG_QUADBUFFER too
	// NOTE: DOUBLEBUFFER are flicker on some cards & drivers (nVIDIA)
	EnableBuffering(FG_TRIPLEBUFFER);

	// set main loop code
	app.SetDelayProc(animate);

	// go!
	app.Run();

	DisableBuffering();
	return 0;
}

