/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2000  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@internet.alcatel.sk
*/
#include <fastgl/fastgl.h>

extern "C" const unsigned int _12x24[];

unsigned char font08x16[4096];

int main(int argc, char **argv)
{
	App myapp(3,argc,argv,0);

    // font from file
    FILE *fp = fopen("8x16.bin", "rb");
    if (fp)
    {
		fread(font08x16, 4096, 1, fp);
		fclose(fp);
    }

	set_colors(CWHITED, CBLACK);

	// in-image font
	int fnt1 = register_font_fix(
       (unsigned char*)_12x24,
       12, 		// width
       24,		// height
       256, 	// number of chars per font
       0);		// characters start at positions
	   
	int fnt2 = register_font_fix(
       font08x16,
       8,
       16,
       256,
       0);

	set_font(fnt1);
    gprintf(80, 220, "This is a new static linked font!");

	set_font(fnt2);
    gprintf(80, 280, "This is a new dynamic loaded font!");

    
	set_font(FONTSYS);
    gprintf(80, 430, "Font 6 - 01234 !@#$%qwertQWERTY }{");
    
	set_font(FONTSYSLIGHT);
    gprintf(80, 460, "Font 7 - 01234 !@#$%qwertQWERTY }{");
	set_font(3);
    gprintf(80, 310, "Font 3 - 01234 !@#$%qwertQWERTY }{");
    
	set_font(4);
    gprintf(80, 340, "Font 4 - 01234 !@#$%qwertQWERTY }{");
    
	set_font(5);
    gprintf(80, 370, "Font 5 - 01234 !@#$%qwertQWERTY }{");
    
	set_font(1);
    gprintf(280, 560, "press <ALT+X> to return");

	myapp.Run();
	return 0;
}

