#include <fastgl/fastgl.h>
#include <fastgl/widgets.h>
#include <fastgl/listbox.h>
#include <fastgl/fgstring.h>

#ifdef BPP8
#warning "compile with -DBPP16 for jpg & png support"
#endif

#ifdef __WATCOMC__
#define random rand
#endif
static int zoom = 1;
static int automat = 0;
static int cas = 5;
static int randm = 0;
static Window *NastaveniaPtr;

class TWindow;
static TWindow *MyWnd;
static void switch_res(CallBack);

class TWindow : public Window
{
		FGList<char *> images;
		FGList<char *>::iterator cimage;
		Bitmap *bmp;
		int x,y,count;
		
		int reload()
		{
			char buf[256];
			images.clear();
			FILE *fp=fopen("file.lst","r");
			if (fp==0)
			{
				system("find -name '*.pcx' >  file.lst");
				system("find -name '*.jpg' >> file.lst");
				system("find -name '*.gif' >> file.lst");
				system("find -name '*.pcx' >> file.lst");
				system("find -name '*.bmp' >> file.lst");
				system("find -name '*.png' >> file.lst");
			}
			if (fp==0) fp=fopen("file.lst","r");
			if (fp)
			{
				while(!feof(fp))
				{
					fgets(buf,255,fp);
					if (buf[strlen(buf)-1] == '\n')
						buf[strlen(buf)-1]=0;
					images.push_back(strdup(buf));
				}
				fclose(fp);
			}
			cimage = images.begin();
			return images.size();
		}
		void render()
		{
			if (bmp) delete bmp;
			bmp = new Bitmap(*cimage);
			if (zoom && (w<bmp->GetW() || h<bmp->GetH()))
			{
				float rx = (float)w/bmp->GetW();
				float ry = (float)h/bmp->GetH();
				if (rx<ry) bmp->stretch(int(bmp->GetW()*rx), int(bmp->GetH()*rx));
				else bmp->stretch(int(bmp->GetW()*ry), int(bmp->GetH()*ry));
			}
		}
		void show()
		{
			x = (w-bmp->GetW())/2;
			y = (h-bmp->GetH())/2;
			_draw();
		}
		void _draw()
		{
			set_fcolor(0);
			box(0,0,w,h);
			WindowLock();
			WindowPutBitmap(x,y,0,0,bmp->GetW(),bmp->GetH(),bmp);
			WindowText(4,GetHW()-16,*cimage,CYELLOW);
			WindowUnLock();
		}
		static void Automat(int t)
		{
			if ((t%cas)==0 && automat)
			MyWnd->OnKeyPress(' ');
		}

		static void casovac(CallBack)
		{
			cApp->SetTimerProc(Automat);
		}
		static void Options(CallBack)
		{
			if (NastaveniaPtr)
				delete NastaveniaPtr;
			NastaveniaPtr = new Window(&NastaveniaPtr, 2000, 2000, 276, 260, "Options", 0, CYELLOW, CGRAYED, WFRAMED|WTITLED|WCLICKABLE);
			NastaveniaPtr->WindowBox(0,164,280,80,CGRAY2);
			set_colors(0,CGRAY2);
			set_font(FONTSYSMEDIUM);
			NastaveniaPtr->printf(26,194,"Press the RIGHT BUTTON or SPACE");
			NastaveniaPtr->printf(90,210,"to the next image");

			NastaveniaPtr->AddCheckButton(16, 16, "stretch images if needed", 'z', &zoom);
			NastaveniaPtr->AddCheckButton(16, 48, "automat", 'a', &automat);
			NastaveniaPtr->AddCheckButton(16, 80, "random", 'r', &randm);
			NastaveniaPtr->AddEditBox(112, 72, 72, 40, "time [s]", 't', &cas, casovac, 1, 999);
			NastaveniaPtr->AddPushButton(38, 170, 60, 21, "Close", 'c', Control::Close);
			NastaveniaPtr->AddPushButton(174, 170, 60, 21, "Quit", 'q', Control::Quit);
			NastaveniaPtr->AddPushButton(16, 112, 96, 21, "640x480", 0,  switch_res);
			NastaveniaPtr->AddPushButton(16, 138, 96, 21,  "800x600", 0,  switch_res);
			NastaveniaPtr->AddPushButton(152, 112, 96, 21,  "1024x768",  0, switch_res);
			NastaveniaPtr->AddPushButton(152, 138, 96, 21,  "1280x1024", 0, switch_res);
		}
		
	public:
		// overload standard fnc
		virtual void OnEndDrag(int ,int , int , int , int)
		{
			int a,b,c,d;
			GuiEvent::GetDragVector(a,b,c,d);
			x += c;
			y += d;
			_draw();
		}
		void OnPaint(void)
		{
			show();
		}
		void OnKeyPress(int key)
		{
			int i;
			switch(key)
			{
			case ' ':
			case PGDOWN:
#ifdef INDEX_COLORS
				render();
#endif
				show();
				for(i=500;i;i--)
				{
					if (randm==0)
					{
						++cimage;
						++cimage;
						if (images.end() == cimage)
							cimage = images.begin();
						--cimage;
					}
					else
					{
#ifndef __BORLANDC__
						cimage = images.begin() + int(random()%count);
#else
						cimage = images.begin() + int(random(count));
#endif
					}
					FILE *f = fopen(*cimage, "r");
					if (f==0) continue;
					fclose(f);
					break;
				}
				if (i==0) IError("No images available!",1);
#ifndef INDEX_COLORS
				else
					render();
#endif
				break;
			case CR:
				Options(0);
				break;
			}
		}
		TWindow(TWindow **self) : Window((Window **)self,0,0,X_width,Y_width,"Okno",0, CWHITE, CBLACK, WUNMOVED|WNOPICTO|WCLICKABLE)
		{
			cCfg->ReadInt("zoom",zoom);
			cCfg->ReadInt("automat",automat);
			cCfg->ReadInt("cas",cas);
			cCfg->ReadInt("random",randm);
			bmp = 0;
			cApp->SetTimerProc(Automat);
			count = reload();
			if (count)
			{
				render();
				show();
				++cimage;
				Options(0);
#ifndef INDEX_COLORS
				render();
#endif
			}
			else IError("No image files!", 1);
		}
		void OnContextPopup(int x, int y)
		{
			OnKeyPress(PGDOWN);
		}
		void OnClick(int x, int y)
		{
			Options(0);
		}
		~TWindow()
		{
			cCfg->WriteInt("zoom",zoom);
			cCfg->WriteInt("automat",automat);
			cCfg->WriteInt("cas",cas);
			cCfg->WriteInt("random",randm);
			if (bmp) delete bmp;
			App::AppDone();
		}
};

static void switch_res(CallBack cb)
{
	switch(cb->GetLocalId()-5)
	{
		case 1:
			graph_change_mode(640, 480);
			break;
		case 2:
			graph_change_mode(800, 600);
			break;
		case 3:
			graph_change_mode(1024, 768);
			break;
		case 4:
			graph_change_mode(1280, 1024);
			break;
	}
	if (MyWnd)
	{
		MyWnd->WindowShape(0,0,X_width,Y_width);
		Window::ShowAll();
	}
}

class TForm : public App
{
	public:
		TForm(int argc, char **argv)
			: App(G640x480,argc,argv,0,APP_CFG|APP_ENABLEALTX)
		{
			set_font(FONTSYS);
			SetColorFuzzy(3);
			MyWnd = new TWindow(&MyWnd);
		}
		~TForm()
		{
			delete MyWnd;
		}
};

//void aaa(FGPixel ){}

int main(int argc, char **argv)
{
	TForm MyApp(argc, argv);
//	new ColorDialog("", aaa);
	MyApp.Run();

	return 0;
}

